---
title:  Available layers
description: A list of available layers in SpaceVim.
keywords: layer,layers
---

## Introduction

SpaceVim is a community-driven vim distribution that seeks to provide layer feature. here is an example for loadding a layer with some specified options:

```vim
call SpaceVim#layers#load('shell',
        \ {
        \ 'default_position' : 'top',
        \ 'default_height' : 30,
        \ }
        \ )
```

<!-- SpaceVim layer list start -->

## Available layers

| Name                                                            | Description                                                                                                               |
| --------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------- |
| [autocomplete](https://spacevim.org/layers/autocomplete/)       | This layer provides auto-completion to SpaceVim                                                                           |
| [chat](https://spacevim.org/layers/chat/)                       | SpaceVim chatting layer provide chatting with qq and weixin in vim.                                                       |
| [checkers](https://spacevim.org/layers/checkers/)               | This layer provides syntax checking feature                                                                               |
| [chinese](https://spacevim.org/layers/chinese/)                 | Layer for chinese users, include chinese docs and runtime messages                                                        |
| [colorscheme](https://spacevim.org/layers/colorscheme/)         | colorscheme provides a list of colorscheme for SpaceVim, default colorscheme is gruvbox with dark theme.                  |
| [default](https://spacevim.org/layers/default/)                 | lt layer contains none plugins, but it has some better default config for vim and neovim                                  |
| [git](https://spacevim.org/layers/git/)                         | This layers adds extensive support for git                                                                                |
| [index](https://spacevim.org/layers/index/)                     | list of available layers in SpaceVim                                                                                      |
| [lang#c](https://spacevim.org/layers/lang/c/)                   | This layer is for c/c++/object-c development                                                                              |
| [lang#java](https://spacevim.org/layers/lang/java/)             | This layer is for Java development                                                                                        |
| [lang#javascript](https://spacevim.org/layers/lang/javascript/) | This layer is for JaveScript development                                                                                  |
| [lang#lisp](https://spacevim.org/layers/lang/lisp/)             | for lisp development                                                                                                      |
| [lang#markdown](https://spacevim.org/layers/lang/markdown/)     | Edit markdown within vim, autopreview markdown in the default browser, with this layer you can also format markdown file. |
| [lang#php](https://spacevim.org/layers/lang/php/)               | This layer adds PHP language support to SpaceVim                                                                          |
| [lang#python](https://spacevim.org/layers/lang/python/)         | This layer is for Python development, provide autocompletion, syntax checking, code format for python file.               |
| [lang#ruby](https://spacevim.org/layers/lang/ruby/)             | This layer is for ruby development, provide autocompletion, syntax checking, code format for ruby file.                   |
| [lang#typescript](https://spacevim.org/layers/lang/typescript/) | This layer is for TypeScript development                                                                                  |
| [lang#vim](https://spacevim.org/layers/lang/vim/)               | This layer is for writting vim script, including code completion, syntax checking and buffer formatting                   |
| [shell](https://spacevim.org/layers/shell/)                     | This layer provide shell support in SpaceVim                                                                              |
| [tags](https://spacevim.org/layers/tags/)                       | This layer provide tags manager for project                                                                               |
| [ui](https://spacevim.org/layers/ui/)                           | Awesome UI layer for SpaceVim, provide IDE-like UI for neovim and vim in both TUI and GUI                                 |

<!-- SpaceVim layer list end -->

<!-- vim:set nowrap: -->
